=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeGuiImpl.java	2021-06-09 13:50:54 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeGuiImpl.java	2021-06-17 18:05:43 +0000
@@ -1399,7 +1538,7 @@
        * @param   reverse
        *          Reverse order.
        */
-      public NodesIterator(TreeNode<T> root, boolean visibleOnly, boolean reverse)
+      public NodesIterator(final TreeNode root, final boolean visibleOnly, final boolean reverse)
       {
          this.reverse = reverse;
 
@@ -1408,7 +1547,6 @@
          {
             stack.push(reverse ? new ReverseListIterator(root.nodes) : root.nodes.listIterator());
          }
-
          this.visibleOnly = visibleOnly;
       }
 
@@ -1422,7 +1560,7 @@
       @Override
       public boolean hasNext()
       {
-         for (Iterator<TreeNode<T>> it : stack)
+         for (Iterator<TreeNode> it : stack)
          {
             if (it.hasNext())
             {
@@ -1440,7 +1578,7 @@
        * @throws  NoSuchElementException if the iteration has no more elements
        */
       @Override
-      public TreeNode<T> next()
+      public TreeNode next()
       {
          if (stack.isEmpty())
          {
@@ -1454,14 +1592,14 @@
             ascend = true;
          }
 
-         ListIterator<TreeNode<T>> it = stack.isEmpty() ? null : stack.peek();
+         ListIterator<TreeNode> it = stack.isEmpty() ? null : stack.peek();
 
          if (it == null || !it.hasNext())
          {
             throw new NoSuchElementException();
          }
 
-         TreeNode<T> node = it.next();
+         TreeNode node = it.next();
          if (reverse)
          {
             while (!ascend &&
@@ -1491,7 +1629,7 @@
    /**
     * Represents the tree node editor.
     */
-   protected static class TreeEditor<N extends TreeNodeEntry, C extends TreeConfig<N>>
+   protected static class TreeEditor
    extends BorderedPanelGuiImpl
    {
       /** Output manager */
@@ -1501,7 +1639,7 @@
       private final CoordinatesConversion cc;
       
       /** The parent container */
-      private final TreeGuiImpl<C,?,?> owner;
+      private final TreeGuiImpl owner;
       
       /** The consumer of the edited value */
       private final Consumer<String> valueConsumer;
@@ -1510,7 +1648,7 @@
       private final Runnable onHideCallback;
       
       /** The related node */
-      private TreeNode<?> editedNode;
+      private TreeNode editedNode;
 
       private int widthInPixels;
 
@@ -1545,7 +1683,7 @@
       public TreeEditor(GuiDriver<?,?> gd,
                         GuiOutputManager screen,
                         CoordinatesConversion cc,
-                        TreeGuiImpl<C,?,?> owner,
+                        TreeGuiImpl owner,
                         Consumer<String> valueConsumer,
                         Runnable onHideCallback,
                         GuiColorResolver colorResolver,
@@ -1774,7 +1912,7 @@
             
             owner.setState(ScreenBuffer.CHANGED);
             
-            owner.makeNodeConfigDirty(owner.config());
+            TreeGuiImpl.makeNodeConfigDirty(owner.config());
             
             setVisible(false);
             owner.setFocusInt(owner.defaultFocus());

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeListBodyGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeListBodyGuiImpl.java	2020-09-07 16:23:31 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeListBodyGuiImpl.java	2021-06-18 18:40:47 +0000
@@ -66,7 +66,6 @@
 
 package com.goldencode.p2j.ui.client.gui;
 
-import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.client.*;
 import com.goldencode.p2j.ui.client.gui.TreeGuiImpl.*;
 import com.goldencode.p2j.ui.client.gui.theme.*;
@@ -78,8 +77,8 @@
  * @param <N> 
  *        Node type
  */
-public class TreeListBodyGuiImpl<N extends TreeListNodeEntry>
-extends TreeBodyGuiImpl<TreeListConfig<N>, TreeListGuiImpl<N>, N>
+public class TreeListBodyGuiImpl
+extends TreeBodyGuiImpl
 {
    /**
     * Constructor.
@@ -87,7 +86,7 @@
     * @param treeView
     * The owning tree view.
     */
-   public TreeListBodyGuiImpl(TreeListGuiImpl<N> treeView)
+   public TreeListBodyGuiImpl(TreeGuiImpl treeView)
    {
       super(treeView);
    }
@@ -109,7 +108,7 @@
       NativePoint p = tree.screenPhysicalLocation();
       NativePoint scrollLocation = physicalLocation();
       NativePoint point = new NativePoint(x - p.x,
-               y - p.y - tree.getCaptionNativeHeight() - scrollLocation.y);
+               y - p.y - ((TreeListGuiImpl)tree).getCaptionNativeHeight() - scrollLocation.y);
       
       return point;
    }
@@ -127,18 +126,14 @@
       final NativeDimension dim = physicalDimension();
       final NativeRectangle clip = clipRectangle(p, dim);
 
+      final TreeNode topNode = tree.findNode(tree.config.topNode);
+
       // clippable drawing start
-      gd.draw(p, clip, () -> theme.drawTreeListBody(gd,
-                                                    gc,
-                                                    tree.resolveFontCache(),
-                                                    tree,
-                                                    tree.rootNode.nodes,
-                                                    tree.getCurrentNode(),
-                                                    dim,
-                                                    selectionBack,
-                                                    selectionFore,
-                                                    disabledFore,
-                                                    tree.getColumns()));
+      gd.draw(p, clip, () -> {
+         theme.drawTreeListBody(gd, gc, tree.resolveFontCache(), ((TreeListGuiImpl) tree),
+                  topNode, tree.getCurrentNode(), dim.width, dim.height, selectionBack,
+                  selectionFore);
+      });
    }
 
    /**
@@ -157,8 +152,9 @@
    public void scroll(Integer newXPosition, Integer newYPosition)
    {
       super.scroll(newXPosition, newYPosition);
-      tree.caption.setPhysicalLocation(physicalLocation.x, 0);
-      tree.caption.repaint();
+      final TreeListCaption caption = ((TreeListGuiImpl)tree).caption;
+      caption.setPhysicalLocation(physicalLocation.x, 0);
+      caption.repaint();
    }
 
    /**
@@ -174,9 +170,9 @@
     * @return  the calculated width.
     */
    @Override
-   protected int calcMaxNodesWidth(List<TreeNode<N>> nodes, int maxWidth, int level)
+   protected int calcMaxNodesWidth(final List<TreeNode> nodes, final int maxWidth, final int level)
    {
-      List<TreeListGuiImpl.ColumnCache> columns = tree.getColumns();
+      List<TreeListGuiImpl.ColumnCache> columns = ((TreeListGuiImpl)tree).getColumns();
       int colCount = columns.size();
       int width = (colCount - 1) * ClassicTheme.TREELIST_COLUMN_SPACING;
       for (TreeListGuiImpl.ColumnCache cc : columns)
@@ -191,4 +187,16 @@
 
       return width;
    }
+   /**
+    * Update the horizontal scrolling model based on this object geometry and contents.
+    * 
+    * @return {@code true} if model was changed as the result of the call.
+    */
+   @Override
+   public boolean updateHScrollModel()
+   {
+      // FIXME
+      // assert false;
+      return false;
+   }
 }

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeListCaption.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeListCaption.java	2021-05-28 17:57:56 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeListCaption.java	2021-06-17 16:15:18 +0000
@@ -80,7 +80,7 @@
 extends AbstractContainer<GuiOutputManager>
 {
    /** Owning tree */
-   private final TreeListGuiImpl<?> tree;
+   private final TreeListGuiImpl tree;
 
    /** GUI driver */
    private final GuiDriver<?,?> gd;
@@ -97,17 +97,17 @@
     * @param   tree
     *          The owning tree widget.
     */
-   public TreeListCaption(TreeListGuiImpl<?> tree)
+   public TreeListCaption(final TreeListGuiImpl tree)
    {
       this.tree = tree;
-      TreeListConfig<?> c = tree.config();
+      final TreeConfig cfg = tree.config();
 
       // initialize screen driver
       gd = (GuiDriver<?,?>) OutputManager.getDriver();
 
       // color initializing
-      int bgColor = isThreeD() && !c.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
-      gc = new GuiColorResolver(gd, c, bgColor, SysColor.COLOR_BTNTEXT);
+      int bgColor = isThreeD() && !cfg.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
+      gc = new GuiColorResolver(gd, cfg, bgColor, SysColor.COLOR_BTNTEXT);
 
       // at this point classic theme is expected
       theme = (ClassicTheme) ThemeManager.getCurrentTheme();
@@ -160,7 +160,7 @@
    @Override
    public double height()
    {
-      GuiFontResolver.FontCache font = tree.resolveFontCache();
+      final GuiFontResolver.FontCache font = tree.resolveFontCache();
       int h = font.fontHeight + ClassicTheme.TREELIST_COLUMN_CAPTION_Y_PADDING * 2;
       CoordinatesConversion cc = screen().coordinates();
       return cc.heightFromNative(h);
@@ -213,26 +213,4 @@
          add(ci);
       }
    }
-
-   /**
-    * Finds a caption item widget from its backing model instance.
-    *
-    * @param   column
-    *          Cached column.
-    *
-    * @return  {@linkplain TreeListCaptionItem} instance or {@code null}.
-    */
-   private TreeListCaptionItem findCaptionItem(TreeListGuiImpl.ColumnCache column)
-   {
-      for (Widget<?> w : widgets())
-      {
-         TreeListCaptionItem ci = (TreeListCaptionItem) w;
-         if (Objects.equals(ci.column, column))
-         {
-            return ci;
-         }
-      }
-
-      return null;
-   }
 }

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeListCaptionItem.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeListCaptionItem.java	2021-06-02 15:42:33 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeListCaptionItem.java	2021-06-17 21:43:40 +0000
@@ -101,7 +101,7 @@
    private static final int MIN_WIDTH = 20;
 
    /** Owning tree */
-   private final TreeListGuiImpl<?> tree;
+   private final TreeListGuiImpl tree;
 
    /** GUI driver */
    private final GuiDriver<?,?> gd;
@@ -145,17 +145,17 @@
     * @param   column
     *          Cached column info.
     */
-   public TreeListCaptionItem(final TreeListGuiImpl<?> tree, final ColumnCache column)
+   public TreeListCaptionItem(final TreeListGuiImpl tree, final ColumnCache column)
    {      
       this.id = WidgetId.nextID();
       this.tree = tree;
-      TreeConfig<?> c = tree.config();
+      final TreeConfig c = tree.config();
 
       // initialize screen driver
       gd = (GuiDriver<?,?>) OutputManager.getDriver();
 
       // color initializing
-      int bgColor = isThreeD() && !c.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
+      final int bgColor = isThreeD() && !c.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
       gc = new GuiColorResolver(gd, c, bgColor, SysColor.COLOR_BTNTEXT);
 
       // at this point classic theme is expected
@@ -163,8 +163,7 @@
 
       this.column = column;
 
-      WidgetRegistry<GuiOutputManager> registry = screen().getRegistry();
-      registry.addWidget(this);
+      screen().getRegistry().addWidget(this);
 
       tree.LOGGER.log(Level.FINE, "TreeListCaptionItem created: " + this);
    }
@@ -203,7 +202,7 @@
       gc.colors();
 
       gd.draw(p, clip, () -> {
-         final boolean isLast = tree.config.isLastVisible(column.column);
+         final boolean isLast = ((TreeListConfig)tree.config).isLastVisible(column.column);
          theme.drawTreeListCaptionItem(gd, gc, tree.resolveFontCache(), dim.height, column,
                   this != ghostCaptionItem, isLast);
       });
@@ -319,7 +318,7 @@
          return;
       }
       
-      final TreeListConfig<?> c = tree.config();
+      final TreeConfig c = tree.config();
 
       // column resizing
       if (atResizeEdge && pushLocation != null)
@@ -351,7 +350,7 @@
       else if (c.sorted)
       {
          final int columnIndex = column.index;
-         c.triggerColumn = columnIndex;
+         ((TreeListConfig)c).triggerColumn = columnIndex;
 
          ThinClient.TriggerResult res = ThinClient.getInstance().invokeTriggers(this,
                   Keyboard.SE_COLUMN_SORTING, false);

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeListGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeListGuiImpl.java	2021-06-10 11:50:04 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeListGuiImpl.java	2021-06-18 15:47:47 +0000
@@ -95,27 +95,27 @@
  * @param <N> 
  *        Node type
  */
-public class TreeListGuiImpl<N extends TreeListNodeEntry>
-extends TreeGuiImpl<TreeListConfig<N>, TreeListBodyGuiImpl<N>, N>
+public class TreeListGuiImpl
+extends TreeGuiImpl
 {
    /** Caption */
-   TreeListCaption caption;
+   final TreeListCaption caption = new TreeListCaption(this);
 
    /** Cached column definitions */
-   private final List<TreeListGuiImpl.ColumnCache> columns = new ArrayList<>();
+   public final List<TreeListGuiImpl.ColumnCache> columns = new ArrayList<>();
 
    /** Logger used to log all this treelist events */
    Logger LOGGER = Logger.getLogger(TreeListGuiImpl.class.getName());
    
    /**
-    * Construtor.
+    * Constructor.
     *
     * @param   id
     *          Widget id.
     * @param   cfg
     *          Config instance.
     */
-   public TreeListGuiImpl(WidgetId id, TreeListConfig<N> cfg)
+   public TreeListGuiImpl(final WidgetId id, final TreeListConfig cfg)
    {
       super(id, cfg);
    }
@@ -132,13 +132,12 @@
     *          The config used to initialize this widget.
     */
    @Override
-   public void initialize(WidgetId id, TreeListConfig<N> cfg)
+   public void initialize(WidgetId id, TreeConfig cfg)
    {
       super.initialize(id, cfg);
 
       setLayout(new StackLayout<>(StackLayout.Direction.VERTICAL));
-      caption = new TreeListCaption(this);
-      caption.setVisible(config.showHeader);
+      caption.setVisible(((TreeListConfig)config).showHeader);
       add(0, caption);
 
       doLayout();
@@ -161,13 +160,14 @@
     *          Config reference capturing the config state before the owner's config was modified.
     */
    @Override
-   public void afterConfigUpdate(TreeListConfig<N> beforeUpdate)
+   public void afterConfigUpdate(TreeConfig beforeUpdate)
    {
       super.afterConfigUpdate(beforeUpdate);
 
-      if (caption.isVisible() != config.showHeader)
+      final boolean showHeader = ((TreeListConfig)config).showHeader;
+      if (caption.isVisible() != showHeader)
       {
-         caption.setVisible(config.showHeader);
+         caption.setVisible(showHeader);
       }
 
       doLayout();
@@ -177,11 +177,19 @@
     * Lay out container.
     */
    @Override
-   public void doLayout()
+   public final void doLayout()
    {
-      super.doLayout();
-      body.calcSize();  
-      scrollpane.setHeight(height() - getCaptionHeight());
+      /** Place the scrollable container with the body below the caption, so it
+       * fills all remaining space */
+      final double width = width();
+      final double height = height();
+      caption.setLocation(0, 0);
+      final double captionHeight = caption.height();
+      caption.setSize(width, captionHeight);
+      
+      scrollableContainer.setLocation(0, captionHeight);
+      scrollableContainer.setSize(width, height - captionHeight);
+      scrollableContainer.doLayout();
    }
 
    /**
@@ -189,10 +197,9 @@
     *
     * @return  see above.
     */
-   public int getFirstVisibleColumnIndex()
+   public final int getFirstVisibleColumnIndex()
    {
-      ColumnCache col = getColumns().get(0);
-      return col.index;
+      return getColumns().get(0).index;
    }
 
    /**
@@ -201,9 +208,9 @@
     * @return  valid body instance.
     */
    @Override
-   protected TreeListBodyGuiImpl<N> createBody()
+   protected TreeBodyGuiImpl createBody()
    {
-      return new TreeListBodyGuiImpl<N>(this);
+      return new TreeListBodyGuiImpl(this);
    }
 
    /**
@@ -215,7 +222,7 @@
     * @return  the node text.
     */
    @Override
-   protected String getNodeText(final TreeNode<N> node)
+   protected String getNodeText(final TreeNode node)
    {
       final List<ColumnCache> cols = columns;
       assert !cols.isEmpty();
@@ -225,13 +232,7 @@
          return "";
       }
       
-      final List<Object> values = node.value.cellValues;
-      if (position >= values.size() )
-      {
-         return "";
-      }
-      
-      final Object o = values.get(position);
+      final Object o = node.value.getValue(position);
       return o == null ? "" : o.toString();
    }
 
@@ -242,9 +243,9 @@
     *          List of nodes.
     */
    @Override
-   protected void sortNodes(final List<? extends N> nodes)
+   protected void sortNodes(final List<TreeNodeEntry> nodes)
    {
-      final List<Column> ccolumns = config.columns;
+      final List<Column> ccolumns = ((TreeListConfig) config()).columns;
       for (int i = ccolumns.size() - 1; i >= 0; i--)
       {
          final Column column = ccolumns.get(i);
@@ -256,9 +257,7 @@
 
             final Comparator<String> comparator = desc ? Comparator.reverseOrder()
                      : Comparator.naturalOrder();
-            nodes.sort(Comparator.comparing(node -> index < node.cellValues.size()
-                     ? node.cellValues.get(index).toString()
-                     : "", comparator));
+            nodes.sort(Comparator.comparing(node -> node.getValue(index).toString(), comparator));
             return;
          }
       }
@@ -268,7 +267,7 @@
     * Builds tree model from the config's flat list.
     */
    @Override
-   protected void buildTreeModel()
+   protected final void buildTreeModel()
    {
       /**
        * Transform config.columns to this.columns:
@@ -276,8 +275,7 @@
        * <li>sort by column positions
        */
       gd.withSelectedWindow(WindowManager.resolveWindow(this).getId().asInt(), () -> {
-         final TreeListConfig<N> cfg = config();
-         final List<Column> cfgColumns = cfg.columns;
+         final List<Column> cfgColumns = ((TreeListConfig) config()).columns;
          final Column[] visibleColumns = Iterables
                   .toArray(Iterables.filter(cfgColumns, c -> c.visible), Column.class);
 
@@ -466,8 +464,8 @@
          return;
       }
 
-      final TreeListConfig<?> config = config();
-      final List<Column> configColumns = config.columns;
+      final TreeConfig config = config();
+      final List<Column> configColumns = ((TreeListConfig)config).columns;
       final int configColumnsSize = configColumns.size();
       if (newSourceIndex > sourceIndex)
       {

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeViewBodyGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeViewBodyGuiImpl.java	2021-05-28 17:57:56 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeViewBodyGuiImpl.java	2021-06-17 16:19:20 +0000
@@ -89,7 +89,7 @@
  * Implementation of the tree view body, this is the part of the widget where the user input-output happens.
  */
 public class TreeViewBodyGuiImpl
-extends TreeBodyGuiImpl<TreeViewConfig, TreeViewGuiImpl, TreeViewNodeEntry>
+extends TreeBodyGuiImpl
 {
    /**
     * Constructor.
@@ -97,7 +97,7 @@
     * @param   treeView
     *          The owning tree view.
     */
-   public TreeViewBodyGuiImpl(TreeViewGuiImpl treeView)
+   public TreeViewBodyGuiImpl(TreeGuiImpl treeView)
    {
       super(treeView);
    }
@@ -140,27 +140,28 @@
       final NativeDimension dim = physicalDimension();
       final NativeRectangle clip = clipRectangle(p, dim);
       
-      TreeNode<TreeViewNodeEntry> highlightNode = tree.getDropHighlightNode();
+      TreeNode highlightNode = tree.getDropHighlightNode();
       
       if (highlightNode == null)
       {
          highlightNode = tree.getCurrentNode();
       }
       
-      final TreeNode<TreeViewNodeEntry> dropHighlightOrSelected = highlightNode;
+      final TreeNode dropHighlightOrSelected = highlightNode;
+      final TreeNode topNode = tree.findNode(tree.config.topNode);
       
       // clippable drawing start
       gd.draw(p, clip, () -> theme.drawTreeViewBody(gd,
                                                     gc,
                                                     font,
                                                     tree,
-                                                    tree.rootNode.nodes,
+                                                    topNode,
                                                     dropHighlightOrSelected,
                                                     0,
                                                     dim.width,
+                                                    dim.height,
                                                     selectionBack,
-                                                    selectionFore,
-                                                    disabledFore));
+                                                    selectionFore, disabledFore));
       
       if (tree.isEditorActivated())
       {
@@ -181,27 +182,28 @@
     * @return  the calculated width.
     */
    @Override
-   protected int calcMaxNodesWidth(List<TreeGuiImpl.TreeNode<TreeViewNodeEntry>> nodes, int maxWidth, int level)
+   protected int calcMaxNodesWidth(final List<TreeNode> nodes, final int maxWidth, final int level)
    {
-      for (TreeGuiImpl.TreeNode<TreeViewNodeEntry> node : nodes)
+      int result = maxWidth;
+      for (TreeNode node : nodes)
       {
          int width = calcNodeWidth(node, level);
-         if (width > maxWidth)
+         if (width > result)
          {
-            maxWidth = width;
+            result = width;
          }
 
          if (node.value.expanded && node.nodes != null)
          {
-            width = calcMaxNodesWidth(node.nodes, maxWidth, level + 1);
-            if (width > maxWidth)
+            width = calcMaxNodesWidth(node.nodes, result, level + 1);
+            if (width > result)
             {
-               maxWidth = width;
+               result = width;
             }
          }
       }
 
-      return maxWidth;
+      return result;
    }
 
    /**
@@ -214,7 +216,7 @@
     *
     * @return  the calculated width.
     */
-   private int calcNodeWidth(TreeGuiImpl.TreeNode<?> node, int level)
+   private int calcNodeWidth(TreeNode node, int level)
    {
       ImageWrapper<?> image = tree.getNodeImage(node, true);
       
@@ -243,5 +245,31 @@
    {
       return true;
    }
+
+   /**
+    * Update the vertical scrolling model based on this object geometry and contents.
+    * 
+    * @return {@code true} if model was changed as the result of the call.
+    */
+   @Override
+   public boolean updateVScrollModel()
+   {
+      // FIXME
+      assert false;
+      return false;
+   }
+
+   /**
+    * Update the horizontal scrolling model based on this object geometry and contents.
+    * 
+    * @return {@code true} if model was changed as the result of the call.
+    */
+   @Override
+   public boolean updateHScrollModel()
+   {
+      // FIXME
+      assert false;
+      return false;
+   }
 }
 

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeViewGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeViewGuiImpl.java	2021-05-25 15:17:26 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeViewGuiImpl.java	2021-06-17 16:19:49 +0000
@@ -86,7 +86,7 @@
  * TREEVIEW widget client-side implementation.
  */
 public class TreeViewGuiImpl
-extends TreeGuiImpl<TreeViewConfig, TreeViewBodyGuiImpl, TreeViewNodeEntry>
+extends TreeGuiImpl
 {
    
    /**
@@ -120,9 +120,9 @@
     *          List of nodes.
     */
    @Override
-   protected void sortNodes(final List<? extends TreeViewNodeEntry> nodes)
+   protected void sortNodes(final List<TreeNodeEntry> nodes)
    {
-      nodes.sort(Comparator.comparing(node -> node.text));
+      nodes.sort(Comparator.comparing(node -> node.getValue().toString()));
    }
 
    /**
@@ -134,9 +134,9 @@
     * @return  the node text.
     */
    @Override
-   protected String getNodeText(TreeNode<TreeViewNodeEntry> node)
+   protected String getNodeText(final TreeNode node)
    {
-      return ((TreeViewNodeEntry) node.value).text;
+      return node.value.getValue().toString();
    }
 
    /**

=== modified file 'src/com/goldencode/p2j/ui/client/gui/WindowGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/WindowGuiImpl.java	2021-02-24 23:47:59 +0000
+++ src/com/goldencode/p2j/ui/client/gui/WindowGuiImpl.java	2021-06-17 16:20:05 +0000
@@ -256,7 +256,6 @@
 import java.util.*;
 import java.util.function.*;
 
-import com.goldencode.p2j.oo.core.collections.*;
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.*;

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingEmulatedWindow.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingEmulatedWindow.java	2021-05-21 23:19:22 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingEmulatedWindow.java	2021-06-10 11:58:36 +0000
@@ -502,6 +502,9 @@
       // register listeners for OS window events
       window.addWindowListener(new WindowAdapter()
       {
+         /** Serial Version ID */
+         private static final long serialVersionUID = -640373783569803478L;
+
          @Override
          public void windowIconified(WindowEvent e)
          {
@@ -591,6 +594,9 @@
       
       window.addComponentListener(new ComponentAdapter()
       {
+         /** Serial Version ID */
+         private static final long serialVersionUID = -640373783569803478L;
+
          @Override
          public void componentShown(ComponentEvent e)
          {

